;**********************************************************
;
;
;		         Assembler test file
;       
;
;**********************************************************

;	PLUS4	StartAddress			
	opt		PRG						; Save as a .PRG file
	opt		PLUS4=StartAddress		; save BASIC command to start the program
	org		$1001					; Start of basic


	rsset	$200
TEST11:		rb	1					; structures
TEST12:		rb	2
TEST13:		rw	4

	include			"test.inc"

	Message	"Test1=",TEST11,"  EOF:",Label,"  Eval:",12+(20*4)


Mine		equ		RS


TestLabel	equ		$9000
TestSet		set		$9001
TestSet		set		TestSet+10
TestSet		set		TestSet+10
TestSet		set		TestSet+10
TestSet		set		TestSet+10

	org	$1010
	db			$00,$01,$02,$03,$04,$05,$06,$07
	db			"Test Message!!!!"
	dw			$0000,$0001,$0002,$0003,$0004,$0005,$0006,$0007
	ds			256

StartAddress:
Label:
;@Label
;@Label2
;@Label3
	adc	$1234		 				; $6d	absolute
	adc	$12							; $65	zeropage
	adc	#LO(TestLabel)				; $69	immediate
	adc	$1234,x						; $7d	absolute,x
	adc	$1234,y						; $61	absolute,y
	adc	($11,x)						; $79	(indirect,x)
	adc	($22),y						; $71	(indirect),y
	adc	$33,x						; $75	zeropage,x

	and	$1234						; $2d	absolute
	and	$00							; $25	zeropage
	and	#$00						; $29	immediate
	and	$1234,x						; $3d	absolute,x
	and	$1234,y						; $39	absolute,y
	and	($00,x)						; $21	(indirect,x)
	and	($00),y						; $31	(indirect),y
	and	$00,x						; $35	zeropage,x

	asl	a							; $0a	accumulator
	asl	$1234						; $0e	absolute
	asl	$00							; $06	zeropage
	asl	$1234,x						; $1e	absolute,x
	asl	$00,x						; $35	zeropage,x

	bcc	*-2							; $90	Relative
	bcs	*-2							; $b0	Relative
	beq	*-2							; $f0	Relative
									
	bit	$1234						; $2c	absolute
	bit	$00							; $24	zeropage
									
	bmi	*-2							; $30	Relative
	bne	*-2							; $d0	Relative
	bpl	*-2 						; $10	Relative
									
	brk	$12							; $00	implied
									
	bvc	*-2 						; $50	Relative
	bvs	*-2 						; $70	Relative
									
	clc								; $18	implied
	cld								; $d8	implied
	cli								; $58	implied
	clv								; $b8	implied
									
	cmp	$1234						; $cd	absolute
	cmp	$00							; $c5	zeropage
	cmp	#$00						; $c9	immediate
	cmp	$1234,x						; $d0	absolute,x
	cmp	$1234,y						; $d9	absolute,y
	cmp	($00,x)						; $c1	(indirect,x)
	cmp	($00),y						; $d1	(indirect),y
	cmp	$00,x						; $d5	zeropage,x
									
	cpx	$1234						; $ec	absolute
	cpx	$00							; $e4	zeropage
	cpx	#$00						; $e0	immediate

	cpy	$1234						; $cc	absolute
	cpy	$00							; $c4	zeropage
	cpy	#$00						; $c0	immediate

	dec	$1234						; $ce	absolute
	dec	$00							; $c6	zeropage
	dec	$1234,x						; $de	absolute,x
	dec	$00,x						; $d6	zeropage,x
									
	dex								; $ca	implied
	dey								; $88	implied
			
	dcm	$1234						; $cf	absolute
	dcm	$00							; $c7	zeropage
	dcm	$1234,x						; $df	absolute,x
	dcm	$1234,y						; $db	absolute,y
	dcm	($00,x)						; $c3	(indirect,x)
	dcm	($00),y						; $d3	(indirect),y
	dcm	$00,x						; $d7	zeropage,x
							
	eor	$1234						; $4d	absolute
	eor	$00							; $45	zeropage
	eor	#$00						; $49	immediate
	eor	$1234,x						; $5d	absolute,x
	eor	$1234,y						; $59	absolute,y
	eor	($00,x)						; $41	(indirect,x)
	eor	($00),y						; $51	(indirect),y
	eor	$00,x						; $55	zeropage,x
									
	inc	$1234						; $ee	absolute
	inc	$00							; $e6	zeropage
	inc	$1234,x						; $fe	absolute,x
	inc	$00,x						; $f6	zeropage,x

	inx								; $e8	implied
	iny								; $c8	implied

	ins	$1234						; $ef	absolute
	ins	$00							; $e7	zeropage
	ins	$1234,x						; $ff	absolute,x
	ins	$1234,y						; $fb	absolute,y
	ins	($00,x)						; $e3	(indirect,x)
	ins	($00),y						; $f3	(indirect),y
	ins	$00,x						; $f7	zeropage,x
									
	jmp	$1234						; $4c	absolute
	jmp	($34)						; $6c	(indirect)
									
	jsr	$1234						; $20	absolute
									
	lda	$1234						; $ad	absolute
	lda	$00							; $a5	zeropage
	lda	#$00						; $a9	immediate
	lda	$1234,x						; $bd	absolute,x
	lda	$1234,y						; $b9	absolute,y
	lda	($00,x)						; $a1	(indirect,x)
	lda	($00),y						; $b1	(indirect),y
	lda	$00,x						; $b5	zeropage,x
									
	ldx	$1234						; $ae	absolute
	ldx	$00							; $a6	zeropage
	ldx	#$00						; $a2	immediate
	ldx	$1234,y						; $be	absolute,y
	ldx	$00,y						; $b6	zeropage,y
								
	ldy	$1234						; $ac	absolute
	ldy	$00							; $a4	zeropage
	ldy	#$00						; $a0	immediate
	ldy	$1234,x						; $bc	absolute,x
	ldy	$00,x						; $b4	zeropage,x

	lax	$1234						; $af	absolute
	lax	$00							; $a7	zeropage
	lax	$1234,y						; $bf	absolute,y
	lax	($00,x)						; $a3	(indirect,x)
	lax	($00),y						; $b3	(indirect),y
	lax	$00,y						; $b7	zeropage,y
									
	lsr	a							; $4a	accumulator
	lsr	$1234						; $4e	absolute
	lsr	$00							; $46	zeropage
	lsr	$1234,x						; $5e	absolute,x
	lsr	$00,x						; $56	zeropage,x

	nop								; $ea	implied
									
	ora	$1234						; $0d	absolute
	ora	$00							; $05	zeropage
	ora	#$00						; $09	immediate
	ora	$1234,x						; $1d	absolute,x
	ora	$1234,y						; $19	absolute,y
	ora	($00,x)						; $01	(indirect,x)
	ora	($00),y						; $11	(indirect),y
	ora	$00,x						; $15	zeropage,x
									
	pha								; $48	implied
	php								; $08	implied
	pla								; $68	implied
	plp								; $28	implied
									
	rol	a							; $2a	accumulator
	rol	$1234						; $2e	absolute
	rol	$00							; $26	zeropage
	rol	$1234,x						; $3e	absolute,x
	rol	$00,x						; $36	zeropage,x
									
	ror	a							; $6a	accumulator
	ror	$1234						; $6e	absolute
	ror	$00							; $66	zeropage
	ror	$1234,x						; $7e	absolute,x
	ror	$00,x						; $76	zeropage,x
									
	rti								; $40	implied
	rts								; $60	implied

	sbc	$1234						; $ed	absolute
	sbc	$00							; $e5	zeropage
	sbc	#$00						; $e9	immediate
	sbc	$1234,x						; $fd	absolute,x
	sbc	$1234,y						; $f9	absolute,y
	sbc	($00,x)						; $e1	(indirect,x)
	sbc	($00),y						; $f1	(indirect),y
	sbc	$00,x						; $f5	zeropage,x
									
	sec								; $38	implied
	sed								; $f8	implied
	sei								; $78	implied
									
	sta	$1234						; $8d	absolute
	sta	$00							; $85	zeropage
	sta	$1234,x						; $9d	absolute,x
	sta	$1234,y						; $99	absolute,y
	sta	($00,x)						; $81	(indirect,x)
	sta	($00),y						; $91	(indirect),y
	sta	$00,x						; $95	zeropage,x
									
	stx	$1234						; $8e	absolute
	stx	$00							; $86	zeropage
	stx	$00,y						; $96	zeropage,y
									
	sty	$1234						; $8c	absolute
	sty	$00							; $84	zeropage
	sty	$00,x						; $94	zeropage,x
									
	tax								; $aa	implied
	tay								; $a8	implied
	tsx								; $ba	implied
	txa								; $8a	implied
	txs								; $9a	implied
	tya								; $98	implied











